// written by Shi Lixia
// translate I/O statement using c interface for in_core case
//
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
extern "C" void exit(...);
#endif

#include <stdio.h>

#include "compilerApi.h"
#include "strategy.h"

#include "anls_att.h"
//extern "C" int  strcasecmp(...);
//extern "C" int  strncasecmp(...);

//iooc.cc 
extern int check_order(Impdo_header_def *,io_reference *);
extern SgAssignStmt * construct_index_assign(SgInputOutputStmt *,SgSymbol *,int ,int );
extern void apply_temp_stack(SgStatement *, io_reference *, SgExpression **);
extern SgForStmt * temp_stack_doloop(SgStatement *, io_reference *, SgArrayRefExp *,  SgVarRefExp *,SgArrayRefExp * ,int );

#define MAX_DIM  7
SgExpression * numberSize[MAX_DIM];

void save_numberSize(SgInputOutputStmt *print,io_reference *iref,SgSymbol *numberSymb)
{
  int i;
  for (i=0;i<iref->ihdef->numberOfIndex();i++)
    {
      SgArrayRefExp *numberExp=new SgArrayRefExp(*numberSymb);
      numberExp->setSubscripts(*(new SgValueExp(i+1)));
      numberSize[i]=numberExp; 
    }
}

int is_format_io(SgInputOutputStmt *print)
{
   if (print->variant() == PRINT_STAT) return 1;

   SgExpression *speclist=print->specList();
   SgExpression *expr;
   for(expr=speclist; expr; expr=expr->rhs())
      {
        SgExpression *keyParent=expr->lhs();
        SgKeywordValExp *keyword=isSgKeywordValExp(keyParent->lhs());
        if(keyword != NULL )
        { 
           if(strcasecmp(keyword->value(),"fmt")==0) return 1;
        }
     }
   return 0;
}

SgAssignStmt * number_assign(SgSymbol *number_symb,SgExpression * numberExp,int i_dim )
{
    SgVariableSymb  *array_name=(SgVariableSymb *)number_symb;
    SgArrayRefExp * aryExp=new SgArrayRefExp (*array_name);
    SgExpression * valExp= new SgValueExp(i_dim+1);
    aryExp->addSubscript(*valExp);
    SgAssignStmt * assignStmt = new SgAssignStmt(*aryExp, *numberExp);
    return(assignStmt);
}


void change_datatransfer2C(SgInputOutputStmt *print, SgExpression *onexp)
{
  SgExpression *speclist=print->specList()->copyPtr();
  SgExpression *expr;
  SgSymbol *symb;
  SgSymbol *indexSymb=print->getSymbolInCurrentScope(mixstring,"index",NULL,0);
  SgSymbol *number_symb=print->getSymbolInCurrentScope(mixstring, "number",NULL,0);
  int dimcounter,i;

//  int irefNum=print->numberOfAttributes(Io_Ref);
//  int ihdefNum=print->numberOfAttributes(IHDER_Def);

  io_reference *iref=(io_reference *)print->attributeValue(0,Io_Ref);

  SgSymbol *orgarraysymb = iref->symbol();
  int numOfSubscripts=((SgArrayType*)(iref->symbol()->type()))->dimension();

  int storage = getArrayStorage(orgarraysymb);

  switch(print->variant())
  {
   case READ_STAT:
          symb=print->getSymbolInCurrentScope(mixstring,"read",NULL);
          break;  
   case WRITE_STAT:
          symb=print->getSymbolInCurrentScope(mixstring,"write",NULL);
          break;  
   }
   SgCallStmt *new_print=new SgCallStmt(*symb);
   SgIfStmt * ifstmt = new SgIfStmt(*onexp->copyPtr(), *new_print);
   print->insertStmtBefore(*ifstmt, *print->controlParent());

   dimcounter=0;
   for(i=0;i<numOfSubscripts;i++)  
     {
       if (iref->hasIndexOnDim(i))
       {
         int indexcounter=iref->indexSequenceOnDim(i);
         SgExpression *l=iref->ihdef->getIndexTriplet(dimcounter, 0);
         SgExpression *u=iref->ihdef->getIndexTriplet(dimcounter, 1);
         SgExpression *s=iref->ihdef->getIndexTriplet(dimcounter, 2)?iref->ihdef->getIndexTriplet(dimcounter, 2):(new SgValueExp(1));
         SgExpression *numberExp=&((*u->copyPtr() - *l->copyPtr()) / (*s->copyPtr()) + *(new SgValueExp(1)));  
         numberExp=calculateExp(numberExp); 
         SgAssignStmt *numberAssignStmt=number_assign(number_symb,numberExp,dimcounter);
         new_print->insertStmtBefore(*numberAssignStmt,*new_print->controlParent());
         dimcounter++;
       } 
     }
  
   if((iref->getFunction()!=NULL) && (print->variant()==WRITE_STAT))  
   {
     save_numberSize(print,iref, number_symb);    
     apply_temp_stack(new_print,iref,numberSize);
   }

  // only fit for the situation: numOfSubscripts == iref->ihdef->numberOfIndex()
   dimcounter=0;
   for(i=0;i<numOfSubscripts;i++)  
   {
     if (iref->hasIndexOnDim(i))
     {
       int indexcounter=iref->indexSequenceOnDim(i);
       SgAssignStmt *indexAssignStmt=construct_index_assign(print,indexSymb,dimcounter,indexcounter);
       new_print->insertStmtBefore(*indexAssignStmt,*new_print->controlParent());
       dimcounter++;
     }
   }


//argument 1
   SgExpression *unitExp;
   SgExpression *recExp=NULL;
   for(expr=speclist; expr; expr=expr->rhs())
      {
        SgExpression *keyParent=expr->lhs();
        SgKeywordValExp *keyword=isSgKeywordValExp(keyParent->lhs());
        if(keyword != NULL )
        { 
           if(strcasecmp(keyword->value(),"unit")==0)
               unitExp=keyParent->rhs()->copyPtr();
           if(strcasecmp(keyword->value(),"rec")==0)
               recExp=keyParent->rhs()->copyPtr();
        }
       }
   new_print->addArg(*unitExp);
   if(recExp!=NULL)
   {
     SgSymbol *recSymb=print->getSymbolInCurrentScope(mixstring,"seek",NULL);
     SgCallStmt *seekStmt=new SgCallStmt(*recSymb);
     seekStmt->addArg(*unitExp);
     seekStmt->addArg(*recExp);
     ifstmt->insertStmtAfter(*seekStmt,*ifstmt);
   }
   

// create argument 2
        //  generate real_mb(pcrc_tbs)
     SgSymbol *stack_symb, *newsymb;
     if((iref->getFunction()!=NULL) &&  (print->variant()==WRITE_STAT))
        stack_symb=print->getSymbolInCurrentScope(mixstring, "tbs",NULL);
     else 
        stack_symb=print->getSymbolInCurrentScope(mixstring, "tbs",NULL ,0);
     SgVarRefExp *stack_exp=new SgVarRefExp(stack_symb);
     SgArrayRefExp * array = (SgArrayRefExp *) iref->expression();  
     SgSymbol * arraysymb  = array->symbol();

#ifdef MEM_ALLOC
     if ((iref->getFunction()!=NULL) && (print->variant()==WRITE_STAT))
       newsymb = print->getSymbolInCurrentScope(stackNameOfType(iref->getFunction()->type()),"mb", NULL);
     else
       newsymb = print->getSymbolInCurrentScope(stackNameOfType(array->type()),"mb", NULL);
#else
  SgSymbol * newsymb = print->getSymbolInCurrentScope(mixstring, stackNameOfType(array->type()), NULL);
#endif

     SgArrayRefExp *newarray = new SgArrayRefExp(*newsymb);
     SgArrayRefExp *tempNewArray=(SgArrayRefExp *)newarray->copyPtr();
     newarray->addSubscript(*stack_exp);

     new_print->addArg(*newarray->copyPtr());

// create argument 3
    int dim=iref->ihdef->numberOfIndex();
    SgValueExp *dimExp=new SgValueExp(dim);
    new_print->addArg(*dimExp);

// create argument 4
    SgValueExp *majorExp=new SgValueExp(storage);
    new_print->addArg(*majorExp);

// create argument 5
     int order=check_order(iref->ihdef,iref);
     SgValueExp *orderExp=new SgValueExp(order);
     new_print->addArg(*orderExp);

// create argument 6
    SgArrayRefExp * numberExp=new SgArrayRefExp (*number_symb);
    new_print->addArg(*numberExp->copyPtr());

// create argument 7
    SgExpression * sizeExp;
    if(iref->getFunction()!=NULL && (print->variant()==WRITE_STAT)) 
      sizeExp = get_type_size(print, iref->getFunction()->type());
    else
      sizeExp = get_type_size(print, array->type());
    new_print->addArg(*sizeExp->copyPtr());

// create argument 8
    SgArrayRefExp * indexExp=new SgArrayRefExp (*indexSymb);
    new_print->addArg(*indexExp->copyPtr());
    
   if((iref->getFunction()!=NULL) && (print->variant()==WRITE_STAT))
    {
     SgForStmt *doloop=temp_stack_doloop(print,iref,tempNewArray,stack_exp,numberExp,0);
     new_print->insertStmtBefore(*doloop,*new_print->controlParent());
    }       
}

